<%@ Page Language="C#" 
    MasterPageFile="~/Resources/MasterPages/Modal.Master" 
    CodeBehind="CreateNewConfigurationFile.aspx.cs" 
    Inherits="Inedo.BuildMaster.Web.WebApplication.Applications.Configuration.CreateNewConfigurationFile"  %>

<asp:Content ID="Content1" ContentPlaceHolderID="MainContent" runat="server">

    <asp:PlaceHolder ID="phCreateConfigurationFile" runat="server">
        <bm:InfoBox runat="server"
            ID="ctlFileNameError"
            BoxType="Error"
            Visible="false" />

        <bm:InfoBox runat="server" ID="ctlEnvironmentWarning" BoxType="Warning" Visible="false">
                There are no workflow steps defined for this application, therefore no configuration
                file instances can be created at this time.
        </bm:InfoBox>
        <bm:InfoBox runat="server" ID="ctlLicensingConfigFiles" Visible="false" BoxType="Error">
            You have reached the maximum number of configuration files for this application as permitted by the license.
        </bm:InfoBox>

        <bm:FormFieldGroup runat="server" Narrow="true" ID="ctlDeployable">
            <Description Heading="Deployable">
                Enter the deployable associated with this file.
            </Description>
            <FormFields>
                <bm:StandardFormField LabelText="Deployable:">
                    <FieldContent>
                        <asp:DropDownList runat="server" ID="ddlDeployable">
                            <asp:ListItem Value="0" Text="" />
                        </asp:DropDownList>
                        <bm:StyledRequiredFieldValidator runat="server" ID="vreq_ddlDeployable"
                            InitialValue="0" />
                    </FieldContent>
                </bm:StandardFormField>
            </FormFields>
        </bm:FormFieldGroup>
        
        <bm:FormFieldGroup runat="server" Narrow="true" ID="ctlFileName" EndGroup="false">
            <Description Heading="File">
                Enter a file name for the configuration file.
                e.g. <i>web.config</i>
            </Description>
            <FormFields>
                <bm:StandardFormField runat="server" LabelText="File Name:">
                    <FieldContent>
                        <bm:ValidatingTextBox runat="server"
                            ID="txtFileName"
                            Required="true"
                            MaxLength="500"
                            Width="250"
                            />
                    </FieldContent>
                </bm:StandardFormField>
            </FormFields>
        </bm:FormFieldGroup>
        <bm:FormFieldGroup runat="server"  Narrow="true" ID="ctlEnvironments" EndGroup="false">
            <Description Heading="Instances">
                Select the instances that will be created; these can be changed later.
            </Description>
            <FormFields>
                <bm:StandardFormField runat="server">
                    <FieldContent>
                        <asp:CheckBoxList
                            runat="server" 
                            ID="chklEnvironments"
                            CellPadding="3"
                            RepeatDirection="Vertical"
                            RepeatLayout="Table"
                            DataTextField="Environment_Name"
                            DataValueField="Environment_Id" />
                    </FieldContent>
                </bm:StandardFormField>
            </FormFields>
        </bm:FormFieldGroup>
        <bm:FormFieldGroup runat="server"  Narrow="true" ID="ctlTemplate" EndGroup="true">
            <Description Heading="Templating">
                Determines whether each of the selected instances will be templated.
            </Description>
            <FormFields>
                <bm:StandardFormField runat="server">
                    <FieldContent>
                        <bm:UpgradeOverviewSlim runat="server" ID="ctlLicensingTemplates" WarningText="Configuration file templates are not permitted by this license." />
                        <asp:CheckBox runat="server" ID="chkTemplate" Text="Create Default Template" />
                    </FieldContent>
                </bm:StandardFormField>
            </FormFields>
        </bm:FormFieldGroup>
    </asp:PlaceHolder>

    <div class="action-button-container">
        <asp:Button runat="server"
            ID="btnSaveChanges"
            OnClick="btnSaveChanges_Click"
            Text="Create File" 
            CssClass="button"
            />
    </div>

</asp:Content>
