<%@ Page Language="C#"
    MasterPageFile="~/Resources/MasterPages/Popup.Master"
    CodeBehind="EditConfigurationFile.aspx.cs"
    Inherits="Inedo.BuildMaster.Web.WebApplication.Applications.Configuration.EditConfigurationFile"
    Title="Edit Configuration File" %>

<asp:Content ContentPlaceHolderID="AdditionalHeadContent" runat="server">

    <style type="text/css">
        SPAN.change { background-color: #AAF; color: #009; }
        SPAN.delete { background-color: #FAA; color: #C00; text-decoration: line-through; }
        SPAN.insert { background-color: #CFC; color: #090; }

        body { background-color: #E7E7E7; }

        #Header #Buttons { line-height: 25px; vertical-align: middle; height: 25px; background-image: url('/Resources/images/layout/menubaritem.svg'); background-size: contain; -webkit-background-size: contain; border-radius: 8px; border: solid 1px #AAA; overflow: hidden; }
            #Header #Buttons a.major { font-weight: bold; }
            #Header #Buttons a,
            #Header #Buttons a:hover,
            #Header #Buttons a:visited { color: #707070; text-shadow: 0 1px 0 #fff; display: block; float: left; text-decoration: none; border-right: solid 1px #AAA; padding: 0 12px; }
            #Header #Buttons a:hover { background-image: url('/Resources/images/layout/menubaritemselected.svg'); background-size: contain; }
        
        #Tabs { height: 31px; }
            #Tabs li.extended { z-index: 1; }
        
        .editor, div.diff { background-color: #ffffff; display: block; overflow: hidden; height: 200px; width: 600px; }
        div.editor textarea.editor { position: relative; overflow: scroll; padding: 15px; margin: 0px; border: 0px; box-sizing: border-box; border: 1px solid #ddd; }

        DIV.diff { background-color: #f3f3f3; overflow: scroll; padding: 15px; box-sizing: content-box; }

        #divSaveOptions { margin-top: 15px; width: 98%; }
    </style>

   <script type="text/javascript">
        $(function () {
            $('#Tabs A').click(function () {
                if (!$(this).attr('href')) return;
                var instance = $(this).attr('href').substring(1);

                $('.tabStrip a.active').removeClass('active');
                $(this).addClass('active');
                $('DIV.editor').hide();
                $('DIV.editor').filter('.' + instance).show();

                $('DIV.diff').hide();
                $('DIV.diff').filter('.' + instance).show();

                $('#<%=hdnTabIdx.ClientID %>').val(instance);

                return false;
            });

            if ($('#<%=hdnTabIdx.ClientID %>').val()) {
                $('#Tabs A[href=#' + $('#<%=hdnTabIdx.ClientID %>').val() + ']').click();
            }
            else {
                $('#Tabs A:first').click();
            }

            $('DIV.editor TEXTAREA').each(function () {
                var $tab = $('#Tabs A[href=#' + $(this).attr('class').split(' ')[1] + ']');
                this.inedobm_originalval = $(this).val();
                this.inedobm_originaltxt = $tab.text();
                this.inedobm_$tab = $tab;
            });

            $('DIV.editor TEXTAREA').keyup(function (e) {

                if (ignoredKeyCode(e.keyCode)) return;

                var $this = $(this);
                var $tab = this.inedobm_$tab;
                if ($this.val() == this.inedobm_originalval) {
                    $tab.text(this.inedobm_originaltxt);
                }
                else {
                    $tab.html(this.inedobm_originaltxt + '<span style="color:#AA0000">*</span>');
                }

            });

            $(window)
                .resize(function () {
                    $('div.editor,textarea.editor').height($(window).height() - 250);
                    $('div.diff').height($(window).height() - 430);
                    $('div.editor,textarea.editor,div.diff').width($(window).width() - 50);
                })
                .trigger('resize');
        });


        function ignoredKeyCode(keyCode) {
            switch (keyCode) {
                // ignore non-character keys
                case 9: case 16: case 17: case 18: case 19: case 20: case 27: case 33: case 34: case 35: case 36:
                case 37: case 38: case 39: case 40: case 45: case 91: case 92: case 93: case 112: case 113: case 114:
                case 115: case 116: case 117: case 118: case 119: case 120: case 121: case 122: case 123: case 144:
                case 145:
                    return true;
            }
            return false;
        }
    </script>

</asp:Content>

<asp:Content ContentPlaceHolderID="MainContent" runat="server">

    <div id="Header">
        <div id="Buttons">
            <a class="major" href="ManageConfigurationFileInstances.aspx<%=Request.Url.Query%>"
                onclick="return confirm('Unsaved changes will be lost.\n\nContinue?');">Manage Instances</a>
            <a href="LoadConfigurationFileVersion.aspx?configurationFileId=<%= Request.QueryString["configurationFileId"] %>&source=server"
                onclick="return confirm('Unsaved changes will be lost.\n\nContinue?');">Load From Server</a>
            <a href="LoadConfigurationFileVersion.aspx?configurationFileId=<%= Request.QueryString["configurationFileId"] %>&source=scm"
                onclick="return confirm('Unsaved changes will be lost.\n\nContinue?');">Load From Source Control</a>
            <a href="LoadConfigurationFileVersion.aspx?configurationFileId=<%= Request.QueryString["configurationFileId"] %>&source=upload"
                onclick="return confirm('Unsaved changes will be lost.\n\nContinue?');">Upload File</a>
        </div>
        <h1><%= Server.HtmlEncode(Title) %></h1>
    </div>


    <bm:InfoBox runat="server"
        ID="ctlSaved"
        BoxType="Success"
        Visible="false">
        The configuration file has been saved successfully. Please close this window to continue.
    </bm:InfoBox>

    <div id="Tabs">
        <bm:SimpleTabStrip runat="server" ID="ctlInstanceTabs">
            <NewItemTab Visible="false" />
        </bm:SimpleTabStrip>
    </div>

    <div id="Body">
        <asp:placeholder runat="server" id="phEditors" />

        <asp:placeholder runat="server" id="phDiffs" visible="false">
        <div style="position:absolute;margin-top:5px;margin-left:10px;">
            <strong>Change Preview:</strong>
            <span class="insert">Added</span> 
            <span class="change">Changed</span> 
            <span class="delete">Removed</span>
        </div>
        <div id="divDiffs">
            <asp:PlaceHolder runat="server" ID="phDiffContent" />
        </div>
    </asp:placeholder>

        <div id="divSaveOptions" class="white-box padded-box">
            <bm:FormFieldGroup ID="ctlSaveOptionGroup" runat="server" Narrow="false" EndGroup="true" Visible="false">
                <Description Heading="Save Options">
                    Select the release to associate the changes with and,
                optionally, a change comment.

                    <div style="font-size: 10px;">
                <bm:InfoBox runat="server" ID="ctlNewerReleases" BoxType="Warning" Visible="false">
                    <strong>Note: </strong>You are saving a configuration file instance targeted for a release that is not the latest
                when there is already a saved version for a newer release. This will cause the newer release's 
                configuration file instances to be overwritten and use this configuration. If you have already made changes
                to your configuration for a newer release, you may wish to merge them with these changes.
                </bm:InfoBox>
            </div>

                </Description>
                <FormFields>
                    <bm:StandardFormField LabelText="Release Number:">
                        <FieldContent>
                            <asp:dropdownlist runat="server" id="ddlReleaseNumber" autopostback="true" onselectedindexchanged="ddlReleaseNumber_SelectedIndexChanged" />
                        </FieldContent>
                    </bm:StandardFormField>
                    <bm:StandardFormField LabelText="Change Comments:">
                        <FieldContent>
                            <asp:textbox runat="server" id="txtComments" rows="2" columns="40" textmode="MultiLine" />
                        </FieldContent>
                    </bm:StandardFormField>
                </FormFields>
            </bm:FormFieldGroup>

            <div class="action-button-container">
                <asp:button id="btnPreviewChanges" runat="server" text="Save Changes" cssclass="button" onclick="btnPreviewChanges_Click" />
                <asp:button id="btnCancelPreview" runat="server" text="&laquo; Go back and edit" cssclass="buttonMinor" onclick="btnCancelPreview_Click" visible="false" />
                <asp:button id="btnSaveChanges" runat="server" text="Confirm & Save Changes" cssclass="button" visible="false" onclick="btnSaveChanges_Click" />
                <asp:hiddenfield runat="server" id="hdnTabIdx" />
            </div>
        </div>

    </div>

</asp:Content>
