<%@ Page Language="C#"
    MasterPageFile="~/Resources/MasterPages/Popup.Master"
    CodeBehind="LoadConfigurationFileVersion.aspx.cs"
    Inherits="Inedo.BuildMaster.Web.WebApplication.Applications.Configuration.LoadConfigurationFileVersion"
    Title="Load New Configuration File Version" %>

<asp:Content ID="Content1" ContentPlaceHolderID="AdditionalHeadContent" runat="server">

<style type="text/css">

DIV.FileSource { padding: 10px; }
DIV.FileSource H2 { display: block; }
body { background-color:#E7E7E7; }

#Header #Buttons { line-height: 25px; vertical-align: middle; height: 25px; background-image: url('/Resources/images/layout/menubaritem.svg'); background-size: contain; -webkit-background-size: contain; border-radius: 8px; border: solid 1px #AAA; overflow: hidden; }
    #Header #Buttons a.major { font-weight: bold; }
    #Header #Buttons a,
    #Header #Buttons a:hover,
    #Header #Buttons a:visited { color: #707070; text-shadow: 0 1px 0 #fff; display: block; float: left; text-decoration: none; border-right: solid 1px #AAA; padding: 0 12px; }
    #Header #Buttons a:hover { background-image: url('/Resources/images/layout/menubaritemselected.svg'); background-size: contain; }

#Container { margin: 5px; background-color:#FFF; }

</style>    

<script type="text/javascript">
        $(function(){
            $(window)
                .resize(function(){
                    $('#Container').height( $(window).height() - 80);
                    })
                .trigger('resize');
        });
        
    </script>
</asp:Content>

<asp:Content ContentPlaceHolderID="MainContent" runat="server">
    <div id="Header">
        <div id="Buttons">
            <a href="EditConfigurationFile.aspx<%= Request.Url.Query %>">&laquo; Edit File</a>
        </div>
        <h1><%= HttpUtility.HtmlEncode(Title) %></h1>
    </div>

    <div id="Body"><div id="Container">

        <%-- Step 1000: Select the file (only one of the FileSource divs will be visible) --%>
            <bm:InfoBox runat="server" BoxType="Error" ID="ctlLoadError" Visible="false" />
            
            <bm:FormFieldGroup runat="server" ID="ctlUploadFileGroup" Visible="false" Narrow="true">
                <Description Heading="Local File">
                    Select a file from your computer to use for new file version(s).
                </Description>
                <FormFields>
                    <bm:StandardFormField LabelText="File:">  
                        <FieldContent><asp:FileUpload runat="server" ID="ctlUploadFile" /></FieldContent>
                    </bm:StandardFormField>
                </FormFields>
            </bm:FormFieldGroup>
            
            <bm:FormFieldGroup runat="server" ID="ctlFromServerGroup" Visible="false" Narrow="true">
                <Description Heading="From Server">
                    Select a server and provide a file path for the new file version(s).
                </Description>
                <FormFields>
                    <bm:StandardFormField LabelText="Server:"> 
                        <FieldContent>
                            <asp:DropDownList runat="server" ID="ddlServer" AutoPostBack="true" OnSelectedIndexChanged="ddlServer_SelectedIndexChanged">
                                <asp:ListItem Value="" Text="(select server)" />
                            </asp:DropDownList>
                        </FieldContent>
                    </bm:StandardFormField>
                    <bm:StandardFormField LabelText="File:">
                        <FieldContent>
                            <bm:SourceControlFileFolderPicker runat="server" ID="ctlServerPath" />
                        </FieldContent>
                    </bm:StandardFormField>
                </FormFields>
            </bm:FormFieldGroup>          
            
            <bm:FormFieldGroup runat="server" ID="ctlFromScm" Visible="false" Narrow="true">
                <Description Heading="From Source Control">
                    Select a source control provider and provide a file path for the new file version(s).
                </Description>
                <FormFields>
                    <bm:StandardFormField LabelText="Source Control Provider:">
                        <FieldContent>
                            <asp:DropDownList runat="server" ID="ddlSourceControlProviders" AutoPostBack="true" OnSelectedIndexChanged="ddlSourceControlProviders_SelectedIndexChanged">
                                <asp:ListItem Value="" Text="(select provider)" />
                            </asp:DropDownList>
                        </FieldContent>
                    </bm:StandardFormField>
                    <bm:StandardFormField LabelText="File:">
                        <FieldContent>
                            <bm:SourceControlFileFolderPicker runat="server" ID="ctlScmPath" DisplayMode="FoldersAndFiles" />
                        </FieldContent>
                    </bm:StandardFormField>
                </FormFields>
            </bm:FormFieldGroup>
            
            <bm:FormFieldGroup ID="ctlInstancesGroup" runat="server" EndGroup="true" Narrow="true">
                <Description Heading="Instances">
                    Select the instance(s) that will be replaced.
                </Description>
                <FormFields> 
                    <bm:StandardFormField>
                        <FieldContent>
                            <asp:CheckBoxList runat="server"
                                RepeatDirection="Vertical"
                                ID="chklInstances" />
                            <bm:StyledCustomValidator runat="server"
                                ID="vcstHasSelection_chklInstances"
                                OnServerValidate="vcstHasSelection_chklInstances_ServerValidate"
                                Text="<br />You must select one or more instances to continue." />                        
                        </FieldContent>
                    </bm:StandardFormField>
                </FormFields>
            </bm:FormFieldGroup>

            <div>
                <bm:StyledCustomValidator runat="server"
                    ID="vcstHasFile"
                    OnServerValidate="vcstHasFile_ServerValidate"
                    Text="Please select a file to continue.<br />" />
                <div class="action-button-container">
                <asp:Button runat="server"
                    ID="btnCreate"
                    CssClass="button"
                    OnClick="btnCreate_Click"
                    Text="Load Versions" />
                    </div>
            </div>
        </div>
        
   </div>

</asp:Content>
